import { Libp2p } from "libp2p";
import { Components } from "libp2p/components";
import { DirectSub } from "@dao-xyz/libp2p-direct-sub";
import { DirectBlock } from "@dao-xyz/libp2p-direct-block";
import type { RecursivePartial } from "@libp2p/interfaces";
import type { Transport } from "@libp2p/interface-transport";
import { AddressManagerInit } from "libp2p/address-manager";
import { PeerId } from "@libp2p/interface-peer-id";
import { ConnectionManagerConfig } from "libp2p/connection-manager";
export type Libp2pExtended = Libp2p & {
    directsub: DirectSub;
    directblock: DirectBlock;
};
type CreateOptions = {
    transports?: RecursivePartial<(components: Components) => Transport>[];
    addresses?: RecursivePartial<AddressManagerInit>;
    peerId?: RecursivePartial<PeerId>;
    connectionManager?: RecursivePartial<ConnectionManagerConfig>;
    directory?: string;
};
type ExtendedOptions = {
    blocks?: {
        directory?: string;
    };
};
export declare const createLibp2pExtended: (args?: ExtendedOptions & {
    libp2p?: Libp2p | CreateOptions;
}) => Promise<Libp2pExtended>;
export {};
